<?php

// Id used to identify this page within functions.
$PageID = "REDIRECT";

require_once "common.inc";

require_once "config.inc";
require_once "constants.inc";
require_once "db.inc";
require_once "error.inc";
require_once "layout.inc";
require_once "mgmnt.inc";
require_once "language.inc";
require_once "MARC.inc";
require_once "search.inc";

// NOTE: layout_header() moved inside every if-clause to allow header-level redirect!

// Valid Book ID
if(is_book($_REQUEST['input']))
{
	if(is_last_char($_REQUEST['input'], $config['book_id_suffix']))
		$raw_id = chop_last($_REQUEST['input']);

	// Existing book Id
	if(mysql_num_rows(mysql_query("SELECT book_id FROM books WHERE book_id=".$raw_id)))
	{
		layout_header();
		layout_page_title($langText['VALID_BOOK']);

		// Display book info, similar to book_info.php
		$book = mysql_fetch_array(mysql_query("SELECT * FROM books WHERE book_id=".$raw_id));
		$i = 0;
		$position = 1;
		$criteria = '001';
		$hits_per_page = 1;
		$_REQUEST['element'] = "F";

		//list($YAZ_items, $hits) = search($criteria, $_REQUEST['book_control_number'], $position);
		list($YAZ_items, $hits) = search($criteria, format_control_number($book['book_control_number']), $position, $hits_per_page);

		$headers = array();
		$content = array();

		parseMARC($YAZ_items[0]);
		$row = createMARCRow(return_with_format_syntax($MARC_display_extended));

		$header = (strlen($row['book_title']) > 50) ? substr($row['book_title'], 0, 47) . '...' : $row['book_title'];
		$headers = array($header);
		layout_table_header($headers, array('colspan="2"'));

		while(list($key, $value) = each($row))
		{
			//array_push($content, $row[$key], "&nbsp;");
			layout_table_row(array('<b>' . $langText[strtoupper($key)] . '</b>', $row[$key]));
		}

		layout_table_footer();

		// Appropriate management panel

		print "<br /><br />";
		
		layout_page_info($langText['WHAT_DO_BOOK']);

		if($book['book_borrowed'] == 0)
		{
			$delete = array('page_id' => 'BOOK_DELETE', 'img' => 'licon_book_delete.png', 'href' => 'book_delete.php?id='.$_REQUEST['id'].'&auth='.$_REQUEST['auth'].'&book_id='.$_REQUEST['input'], 'text' => $langText['DELETE_BOOK']);
			$return = array();
		}
		else
		{
			$delete = array();
			$return = array('page_id' => 'RETURN', 'img' => 'licon_book_return.png', 'href' => 'return.php?id='.$_REQUEST['id'].'&auth='.$_REQUEST['auth'].'&stage=2&book_id='.$_REQUEST['input'], 'text' => $langText['RETURN_BOOK']);
		}

		$args = array(	array('page_id' => 'BOOK_INFO', 'img' => 'licon_book_info.png', 'href' => 'book_info.php?id='.$_REQUEST['id'].'&auth='.$_REQUEST['auth'].'&url='.$config['zebra_host'].":".$config['zebra_port']."/".$config['zebra_db'].'&book_control_number='.format_control_number($book['book_control_number']), 'text' => $langText['VIEW_BOOK_INFO']),
						array('page_id' => 'BOOK_EDIT', 'img' => 'licon_book_edit.png', 'href' => 'book_edit.php?id='.$_REQUEST['id'].'&auth='.$_REQUEST['auth'].'&book_control_number='.format_control_number($book['book_control_number']), 'text' => $langText['EDIT_BOOK']),
						$delete,
						$return,
						);

		layout_management_panel($args, TRUE);


	}

	// Deleted book, not yet expunged
	elseif(mysql_num_rows(mysql_query("SELECT del_book_id FROM deleted_books WHERE del_book_id=".$raw_id)))
	{
		//print "<script language='javascript'>location.href='book_add.php?id=".$_REQUEST['id']."&auth=".$_REQUEST['auth']."&stage=0&mode=reincarnate&book_id=".$_REQUEST['input']."'</script>";
		header("Location: book_add.php?id=" . $_REQUEST['id'] . "&auth=" . $_REQUEST['auth'] . "&stage=0&mode=reincarnate&book_id=" . $_REQUEST['input']);
	}
	
	else
	{
		//print "<script language='javascript'>location.href='my_page.php?id=".$_REQUEST['id']."&auth=".$_REQUEST['auth']."';</script>";
		header("Location: my_page.php?id=" . $_REQUEST['id'] . "&auth=" . $_REQUEST['auth']);
	}
}

// Valid and existant card number
elseif(valid_card_number($_REQUEST['input']))
{
	if(is_last_char($_REQUEST['input'], $config['card_number_suffix']))
		$_REQUEST['input'] = chop_last($_REQUEST['input']);

	$row = mysql_fetch_array(mysql_query("SELECT * FROM users WHERE user_card_number=".$_REQUEST['input']));

	layout_header();
	layout_page_title($langText['VALID_EXISTANT_CARD'] . ' ' . $row['user_given_names'] . ' ' . $row['user_surname']);

	?>

	<table border="0" cellspacing="0" cellpadding="4">
		
		<tr>
			<td align="right" valign="bottom"><b><?php print $langText['USER_GIVEN_NAMES'] ?>:</b></td>
			<td align="left" valign="bottom"><?php echo $row['user_given_names'] ?></td>
		</tr>
		<tr>
			<td align="right" valign="bottom"><b><?php print $langText['USER_SURNAME'] ?>:</b></td>
			<td align="left" valign="bottom"><?php echo $row['user_surname'] ?></td>
		</tr>
		<tr>
			<td align="right" valign="bottom"><b><?php print $langText['USER_CARD_NUMBER'] ?>:</b></td>
			<td align="left" valign="bottom"><?php echo format_card_number($row['user_card_number']) ?></td>
		</tr>

	<?php

	if($row['user_card_number'] != $row['user_name'])
	{

	?>

		<tr>
			<td align="right" valign="bottom"><b><?php print $langText['USER_NAME'] ?>:</b></td>
			<td align="left" valign="bottom"><?php echo $row['user_name'] ?></td>
		</tr>

	<?php

	}

	?>

		<tr>
			<td align="right" valign="bottom"><b><?php print $langText['USER_ADDRESS'] ?>:</b></td>
			<td align="left" valign="bottom"><?php echo $row['user_postal_address']."<br />".$row['user_postal_code']." ".$row['user_town'] ?></td>
		</tr>
		<tr>
			<td align="right" valign="bottom"><b><?php	print $langText['USER_EMAIL'] ?>:</b></td>
			<td align="left" valign="bottom"><?php echo $row['user_email'] ?></td>
		</tr>

	<?php

	$res = mysql_query("SELECT *, UNIX_TIMESTAMP(borrowed_date) AS borrowed_epoch FROM borrowed WHERE borrowed_user_id=".$row['user_id']);

	$borrowed = 0;
	$expired = 0;
	$reserved = 0;

	while($borr = mysql_fetch_array($res))
	{
		$borrowed++;
		list($f, $e) = expiry_date($borr['borrowed_epoch']);

		if($e < time())
			$expired++;
	}

	$reserved = mysql_num_rows(mysql_query("SELECT * FROM reservations WHERE reserve_user_id=".$row['user_id']));

	?>

		<tr>
			<td colspan="2">&nbsp;</td>
		</tr>
		<tr>
			<td align="right" valign="bottom"><b><?php print $langText['BORROWED_BOOKS'] ?>:</td>
			<td align="left" valign="bottom"><?php echo $borrowed ?></td>
		</tr>
		<tr>
			<td align="right" valign="bottom"><b><?php print $langText['EXPIRED_BOOKS'] ?>:</td>
			<td align="left" valign="bottom"><?php echo $expired ?></td>
		</tr>
		<tr>
			<td align="right" valign="bottom"><b><?php print $langText['RESERVED_BOOKS'] ?>:</td>
			<td align="left" valign="bottom"><?php echo $reserved ?></td>
		</tr>

	</table>
	
	<br />
	<br />

	<?php

	$management = array();
	$move = array();
	$borrow = array();
	$view_borrowed = array();

	if(my_subordinate($row['user_id']) && $row['user_id'] != USER_ID)
	{
		layout_page_info($langText['WHAT_DO_USER']);

		$management = array('page_id' => 'MANAGEMENT', 'priv' => 'GROUP_MANAGEMENT', 'img' => 'licon_user_management.png', 'href' => 'management.php?id='.$_REQUEST['id'].'&auth='.$_REQUEST['auth'].'&user_id='.$row['user_id'], 'text' => $langText['EDIT_USER_INFO']);
		$move = array('page_id' => 'USER_MOVE', 'img' => 'licon_user_move.png', 'href' => 'user_move.php?id='.$_REQUEST['id'].'&auth='.$_REQUEST['auth'].'&stage=2&user_id='.$row['user_id'], 'text' => $langText['USER_MOVE']);
		$borrow = array('page_id' => 'BORROW', 'img' => 'licon_book_borrow.png', 'href' => 'borrow.php?id='.$_REQUEST['id'].'&auth='.$_REQUEST['auth'].'&stage=2&user_card_number='.format_card_number($row['user_card_number']), 'text' => $langText['BORROW_BOOKS']);

		if(can_view_borrowed($row['user_id']) && $row['user_id'] != USER_ID)
		{
			$view_borrowed = array('page_id' => 'VIEW_BORROWED_BOOKS', 'img' => 'licon_view_borrowed.png', 'href' => 'view_borrowed_books.php?id='.$_REQUEST['id'].'&auth='.$_REQUEST['auth'].'&stage=2&user_card_number='.format_card_number($row['user_card_number']), 'text' => $langText['VIEW_BORROWED_BOOKS']);
		}

	}

	$args = array(	$management,
					$move,
					$view_borrowed,
					$borrow,
					);

	layout_management_panel($args, TRUE);

}

// Valid but not existant card number
elseif(is_last_char($_REQUEST['input'], $config['card_number_suffix']))
{
	layout_header();
	layout_page_title($langText['VALID_CARD']);

	$args = array(	array('page_id' => 'USER_ADD', 'img' => 'licon_user_add.png', 'href' => 'user_add.php?id='.$_REQUEST['id'].'&auth='.$_REQUEST['auth'].'&user_card_number='.$_REQUEST['input'], 'text' => $langText['USER_ADD']),
					array('page_id' => 'USER_SEARCH', 'img' => 'licon_user_search.png', 'href' => 'user_search.php?id='.$_REQUEST['id'].'&auth='.$_REQUEST['auth'], 'text' => $langText['USER_SEARCH']),
					);

	layout_management_panel($args);

}

// Either ISBN or EAN, both verified
elseif(verify_ean($_REQUEST['input']) || verify_isbn($_REQUEST['input']))
{
	layout_header();
	layout_page_title($langText['VALID_EAN_ISBN']);

	if(verify_ean($_REQUEST['input']))
		$isbn = ean2isbn($_REQUEST['input']);
	else
		$isbn = $_REQUEST['input'];

		$i = 0;
		$position = 1;
		$criteria = '020';
		$hits_per_page = 1;
		$_REQUEST['element'] = "F";

		//list($YAZ_items, $hits) = search($criteria, $_REQUEST['book_control_number'], $position);
		list($YAZ_items, $hits) = search($criteria, $isbn, $position, $hits_per_page);

		if($hits)
		{
			$headers = array();
			$content = array();

			parseMARC($YAZ_items[0]);
			$row = createMARCRow(return_with_format_syntax($MARC_display_extended));

			$header = (strlen($row['book_title']) > 50) ? substr($row['book_title'], 0, 47) . '...' : $row['book_title'];
			$headers = array($header);
			layout_table_header($headers, array('colspan="2"'));

			while(list($key, $value) = each($row))
			{
				//array_push($content, $row[$key], "&nbsp;");
				layout_table_row(array('<b>' . $langText[strtoupper($key)] . '</b>', $row[$key]));
			}

			layout_table_footer();
			
			print "<br /><br />";
			
			layout_page_info($langText['WHAT_DO_BOOK']);
		}

		$book_add = array('page_id' => 'BOOK_ADD', 'img' => 'licon_book_add.png', 'href' => 'book_add.php?id='.$_REQUEST['id'].'&auth='.$_REQUEST['auth'].'&stage=2&mode=normal&element=F&book_ean='.$isbn, 'text' => $langText['ADD_BOOK']);
		$search = array('page_id' => 'SEARCH', 'img' => 'licon_book_search.png', 'href' => 'search.php?id='.$_REQUEST['id'].'&auth='.$_REQUEST['auth'].'&criteria=020&query='.$isbn.'&url='. next($remote_database), 'text' => $langText['SEARCH_BOOK']);

		layout_management_panel(array($book_add, $search));

}

// String is given and it matches either the user_given_names or user_surname of a user
elseif(mysql_num_rows(mysql_query("SELECT * FROM users WHERE user_given_names LIKE '%".$_REQUEST['input']."%' OR user_surname LIKE '%".$_REQUEST['input']."%'")))
{
	$res = mysql_query("SELECT * FROM users WHERE user_given_names LIKE '%".$_REQUEST['input']."%' OR user_surname LIKE '%".$_REQUEST['input']."%' ORDER BY user_surname");

	if(mysql_num_rows($res) == 1)
	{
		$row = mysql_fetch_array($res);
		//print "<script language='javascript'>location.href='redirect.php?id=".$_REQUEST['id']."&auth=".$_REQUEST['auth']."&input=".format_card_number($row['user_card_number'])."'</script>";
		header("Location: redirect.php?id=" . $_REQUEST['id'] . "&auth=" . $_REQUEST['auth'] . "&input=" . format_card_number($row['user_card_number']));
	}
	else
	{
		layout_header();
		layout_page_title($langText['VALID_USER_NAME']);

		layout_table_header(array("&nbsp;", $langText['USER_CARD_NUMBER'], $langText['USER_REAL_NAME'], $langText['USER_EMAIL']));

		while($row = mysql_fetch_array($res))
		{
			$content = array();
			$content = array('', format_card_number($row['user_card_number']), format_user_real_name($row), $row['user_email']);

			$content[0] .= '<table border="0" cellspacing="0" cellpadding="0"><tr>';

			if(my_subordinate($row['user_id']) && $row['user_id'] != USER_ID)
				$content[0] .= "
					<td><a href='management.php?id=".$_REQUEST['id']."&auth=".$_REQUEST['auth']."&user_id=".$row['user_id']."'>".layout_insertImg("icon_edit.png")."</a></td>
					<td width='5'></td>
				";

			if(can_view_borrowed($row['user_id']) && $row['user_id'] != USER_ID)
				$content[0] .= "<td><a href='view_borrowed_books.php?id=".$_REQUEST['id']."&auth=".$_REQUEST['auth']."&user_card_number=".$row['user_card_number']."&stage=2'>".layout_insertImg("icon_view_borrowed.png")."</a></td>";

			$content[0] .= '</tr></table>';

			layout_table_row($content);
		}

		layout_table_footer();
		
		print '<br /><br />';

		$search = array('page_id' => 'USER_SEARCH', 'img' => 'licon_user_search.png', 'href' => 'user_search.php?id='.$_REQUEST['id'].'&auth='.$_REQUEST['auth'], 'text' => $langText['USER_SEARCH']);

		layout_management_panel(array($search));

	}
}

// Unknown passed argument
else
{
	//layout_page_title($langText['UNKNOWN']);
	//print "<script language='javascript'>location.href='my_page.php?id=".$_REQUEST['id']."&auth=".$_REQUEST['auth']."';</script>";
	header("Location: my_page.php?id=" . $_REQUEST['id'] . "&auth=" . $_REQUEST['auth']);
}

layout_footer();

?>
